import "SDRPlugins.OrderedPluginLoader";

pluginData = Turbine.PluginData.Load(Turbine.DataScope.Character, 'OPL') or {
	plugins = {}, order = {},
}

-- The highest Ordered Load Number (i.e., the last plugin to load)
greatestLoadNumber = 0

function greatestLoadNumberSet()
	for k, v in pairs( pluginData.order ) do
		if( greatestLoadNumber < k ) then
			greatestLoadNumber = k;
		end
	end
end

greatestLoadNumberSet()

function LoadPlugins()
	for loop=1, greatestLoadNumber do
		for k, v in pairs(pluginData.order) do
			if k == loop then
				Turbine.PluginManager.LoadPlugin(v)
			end
		end
	end
end

-- create a new command line command for OPL options
oplCommand = Turbine.ShellCommand();

-- handle the chat commands
function oplCommand:Execute( name, shellCommand )
	if  shellCommand == "show" then
		plugin = PluginWindow();
	else 
		oplCommand:GetHelp();
	end
end

-- The Help text that outputs when /opl is typed
help = "OPL has the following command:\n\n" ..
	"opl show - Brings up the OPL window to add and change the order of the plugins.";

function oplCommand:GetHelp()
	Turbine.Shell.WriteLine( help );
end

-- add the command to the shell
Turbine.Shell.AddCommand( "opl", oplCommand );

LoadPlugins()

--plugin = PluginWindow();